
/*
 * A collection of structures, addresses, and values associated with
 * the LVL7 PowerPC CPU reference board.
 *
 * Copyright (c) 2000 LVL7 Systems, Inc.
 */
#ifndef __MACH_LVL7_AJ_DEFS
#define __MACH_LVL7_AJ_DEFS

#ifdef __KERNEL__

/* A Board Information structure that is given to a program when
 * prom starts it up -- compatible w/ PPCBoot.
 */
#include <asm/ppcboot.h>

/* Memory map is configured by the PROM startup.
 */
#define IMAP_ADDR		((unsigned int)0xff000000)
#define IMAP_SIZE		((unsigned int)(64 * 1024))

#define LVL7_AJ_FLASH_BASE	0xff800000
#define LVL7_AJ_FLASH_SIZE	0x00800000

/* Interrupt level assignments.
*/
#define FEC_INTERRUPT   SIU_LEVEL1      /* FEC interrupt */
#define PHY_INTERRUPT   SIU_IRQ6        /* MII interrupt */

/* We don't use the 8259.
*/
#define NR_8259_INTS	0

#endif /* __KERNEL__ */

#endif /* __MACH_LVL7_AJ_DEFS */
