/*
 * include/asm-ppc/mousse_serial.h
 * 
 * Definitions for Mousse board on the Broadcom Reference Platform
 *
 * Author: John W. Linville
 *         linville@lvl7.com
 *
 * Copyright 2002 LVL7 Systems Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __ASMPPC_MOUSSE_SERIAL_H
#define __ASMPPC_MOUSSE_SERIAL_H

#include <linux/config.h>

#define MOUSSE_SERIAL_0		0xffe08080
#define MOUSSE_SERIAL_1		0xffe08000

#define RS_TABLE_SIZE  2

/* Rate for the 18.432 Mhz clock for the onboard serial chip */
#define BASE_BAUD ( 18432000 / 16 )

#ifdef CONFIG_SERIAL_DETECT_IRQ
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST|ASYNC_AUTO_IRQ)
#else
#define STD_COM_FLAGS (ASYNC_BOOT_AUTOCONF|ASYNC_SKIP_TEST)
#endif

#define STD_SERIAL_PORT_DFNS \
        { 0, BASE_BAUD, MOUSSE_SERIAL_0, 20, STD_COM_FLAGS, /* ttyS0 */   \
		iomem_base: (u8 *)MOUSSE_SERIAL_0,			  \
		io_type: SERIAL_IO_MEM },				  \
        { 0, BASE_BAUD, MOUSSE_SERIAL_1, 20, STD_COM_FLAGS, /* ttyS1 */   \
		iomem_base: (u8 *)MOUSSE_SERIAL_1,			  \
		io_type: SERIAL_IO_MEM },

#define SERIAL_PORT_DFNS \
        STD_SERIAL_PORT_DFNS

#endif /* __ASMPPC_MOUSSE_SERIAL_H */
