/*
 * (C) Copyright 2002
 * John W. Linville, LVL7 Systems, Inc., linville@lvl7.com
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * PCI routines
 */

#include <ppcboot.h>
#include <command.h>
#include <cmd_boot.h>
#include <asm/processor.h>
#include <pci.h>
#include <asm/io.h>

void pci_bmw_fixup_irq(struct pci_controller *hose, pci_dev_t dev)
{
	uchar line;

	switch(PCI_DEV(dev)) {
	case 0x0d:
		line = 0x01;
		break;

	case 0x0e:
	default:
		line = 0x02;
		break;
	}

	pci_hose_write_config_byte(hose, dev, PCI_INTERRUPT_LINE, line);
}


struct pci_controller hose = {
	fixup_irq: pci_bmw_fixup_irq,
};

void pci_init(bd_t *bd)
{
	pci_mpc824x_init(bd, &hose);
}
