/*
 * (C) Copyright 2001
 * LVL7 Systems, Inc., 13000 Weston Pkwy, Suite 105, Cary, NC 27513
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* ------------------------------------------------------------------------- */

#define FLASH_OR0VALUE		0xFFC00742
#define FLASH_BR0VALUE		0xFE000001

/* ------------------------------------------------------------------------- */

/* These values are specifically for a 64Mb DIMM.  When I2C is configured,
 * will need to read ID from DIMM and set values accordingly... -- JWL
 */

/* these values are taken from vxWorks boot code. kumar */
/* on switchcore port A controls flash protecting and ALARM LED */

#define PA15	(0x0001)
#define PA14	(0x0002)
#define PA13	(0x0004)
#define PA12	(0x0008)
#define PA11	(0x0010)
#define PA10	(0x0020)
#define PA9	(0x0040)
#define PA8	(0x0080)
#define PA7	(0x0100)
#define PA6	(0x0200)
#define PA5	(0x0400)
#define PA4	(0x0800)
#define PA3	(0x1000)
#define PA2	(0x2000)
#define PA1	(0x4000)
#define PA0	(0x8000)

#define SDRAM_PADIRVALUE 	(PA0 | PA1 | PA6 | PA9 | PA10 | PA11 | PA13)
#define SDRAM_PADATVALUE 	0x8000
#define SDRAM_PADATVALUE_ALARM	0
#define SDRAM_PADATVALUE_FLASH  (PA13)

/*NH changed to bring into line with vxWorks BSP*/
/*we should be able to make this 0x400 but we need
*to guarantee a sufficient refresh rate
*/
#define SDRAM_MPTPRVALUE 	0x0800

#define SDRAM_MBMRVALUE0 	0x18164114
#define SDRAM_MBMRVALUE1 	0x18964114

#define SDRAM_MARVALUE   	0x000000C8

/* ------------------------------------------------------------------------- */
