/*
 * PPCBoot configuration file for SwitchCore's Zeta boards.
 *
 * Copyright (c) 2002 LVL7 Systems, Inc., 13000 Weston Pkwy, Cary, NC 27513
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#include <../board/sc/zeta/zeta.h>

#define CONFIG_MPC860		1
#define CONFIG_SCZETA		1

#define CONFIG_BOARD_PRE_INIT	1

#define CONFIG_MISC_INIT_R	1

#define CONFIG_8xx_GCLK_FREQ	48000000

#define CONFIG_8xx_CONS_SMC1	1
#define CONFIG_BAUDRATE		9600

#define CONFIG_BOOTDELAY	5
#define CONFIG_BOOTCOMMAND	"echo Not configured!  Run configure script..."
#define CONFIG_BOOT_RETRY_TIME	-1
#define CONFIG_BOOT_RETRY_MIN	30

#define CONFIG_AUTOBOOT_KEYED
#define CONFIG_AUTOBOOT_PROMPT	"autoboot in %d seconds (SPACE to stop)...\n"
#define CONFIG_AUTOBOOT_STOP_STR	" "

#define CONFIG_ZERO_BOOTDELAY_CHECK

#define CONFIG_RTC_MPC8xx	1

#define CONFIG_RAMBOOTCOMMAND	"setenv bootargs root=/dev/ram ; " \
    "bootm fe060000 fe100000"

#define CONFIG_NFSBOOTCOMMAND	"setenv bootargs root=/dev/nfs " \
    "ip=\"$ipaddr\":\"$serverip\":\"$gatewayip\":\"$netmask\" ; tftpboot"

#define CONFIG_EXTRA_ENV_SETTINGS "autostart=yes\0" \
                                  "nfsprep=setenv bootcmd run nfsboot ; " \
                                  "saveenv\0" \
                                  "flashprep=setenv bootcmd run ramboot ; " \
                                  "saveenv\0" \
                                  "bootfile=sc_kernel.image\0"

#define CONFIG_COMMANDS 	(CONFIG_CMD_DFL | \
				 CFG_CMD_DHCP | \
				 CFG_CMD_REGINFO | \
				 CFG_CMD_IMMAP | \
				 CFG_CMD_I2C | \
                                 CFG_CMD_EEPROM | \
				 CFG_CMD_JFFS2 | \
				 CFG_CMD_SDRAM | \
				 CFG_CMD_MII | \
				 CFG_CMD_DATE | \
				 CFG_CMD_ELF)

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#undef CONFIG_WATCHDOG /* come-back later for this */

#define CONFIG_MII

#define CONFIG_I2C
#define CFG_I2C_SPEED	50000
#define CFG_I2C_SLAVE	0xFE

#define CFG_I2C_MULTI_EEPROMS
#define CFG_I2C_EEPROM_ADDR_LEN 1

#define CONFIG_HARD_I2C

#define FEC_ENET		1
#define CFG_DISCOVER_PHY

#define CFG_LONGHELP		1

#define CFG_PROMPT		"=>"

#define CFG_HUSH_PARSER
#ifdef  CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2     "> "
#endif

#define CFG_CBSIZE		1024

#define CFG_PBSIZE 		(CFG_CBSIZE+sizeof(CFG_PROMPT)+16)

#define CFG_MAXARGS		16

#define CFG_BARGSIZE		CFG_CBSIZE
 
#define CFG_BAUDRATE_TABLE      { 9600, 19200, 38400, 57600, 115200 }

#define CFG_MEMTEST_START	0x0100000
#define CFG_MEMTEST_END		0x0400000
 
#define CFG_SDRAM_BASE		0x00000000
#define CFG_FLASH_BASE		0xFE000000

#define CFG_MONITOR_BASE	TEXT_BASE
#define CFG_MONITOR_LEN		(384 << 10)

#define CFG_MALLOC_LEN		(512 << 10)

#define CFG_BOOTMAPSZ		(8 << 20)

#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	32	/* max number of sectors on one chip */
#define CFG_FLASH_ERASE_TOUT	8000	/* flash erase timeout (in ms) */
#define CFG_FLASH_WRITE_TOUT	500	/* flash write timeout (in ms) */

#define CFG_ENV_IS_IN_FLASH	1
#define CFG_ENV_OFFSET		0x00040000
#define CFG_ENV_SECT_SIZE	0x00020000

#define CFG_CACHELINE_SIZE	16
#define CFG_IMMR		0xFF000000
#define CFG_SIUMCR		0x00602000
#define CFG_SYPCR		(SYPCR_SWTC | SYPCR_BMT | SYPCR_BME | SYPCR_SWF)
#define CFG_TBSCR		TBSCR_TBF
#define CFG_RTCSC		(0x0102)
#define CFG_PISCR		PISCR_PITF
#define CFG_PLPRCR		0x00B05000
#define CFG_DER			0

#define CFG_MAMR		0x00001000

#define SCCR_MASK		0xffffffff
#define CFG_SCCR		0

#define CFG_OR0_PRELIM		FLASH_OR0VALUE
#define CFG_BR0_PRELIM		FLASH_BR0VALUE

/*
 * Definitions for initial stack pointer and data area (in DPRAM)
 */
#define CFG_INIT_RAM_ADDR       CFG_IMMR
#define CFG_INIT_RAM_END        0x3000  /* End of used area in DPRAM */
#define CFG_INIT_DATA_SIZE      64  /* size in bytes rsrvd for initial data */
#define CFG_INIT_DATA_OFFSET    (CFG_INIT_RAM_END - CFG_INIT_DATA_SIZE)
#define CFG_INIT_SP_OFFSET      CFG_INIT_DATA_OFFSET

#define CFG_LOAD_ADDR		0x00100000
 
#define CFG_HZ			1000

/*
 * JFFS2 Configuration
 */
#define CFG_JFFS2_FIRST_BANK	0
#define CFG_JFFS2_NUM_BANKS	1
#define CFG_JFFS2_FIRST_SECTOR	0

/*
 * CompactFlash
 */
#define CONFIG_DOS_PARTITION

#if 0 /*JWL*/

#define CFG_PCMCIA_PBR0 0xF4010000
#define CFG_PCMCIA_POR0 0x78011541
#define CFG_PCMCIA_PBR1 0xF4010400
#define CFG_PCMCIA_POR1 0x78011551
#define CFG_PCMCIA_PBR2 0xF4010800
#define CFG_PCMCIA_POR2 0x78021559

#define CONFIG_IDE_8xx_DIRECT   1   /* PCMCIA interface required    */

#define CFG_IDE_MAXBUS          1   /* max. 2 IDE busses        */
#define CFG_IDE_MAXDEVICE       1   /* max. 2 drives per IDE bus */

#define CFG_ATA_BASE_ADDR	0xF4010000
#define CFG_ATA_IDE0_OFFSET     0x0000
#undef  CFG_ATA_IDE1_OFFSET

#define CFG_ATA_DATA_OFFSET     0x0000  /* Offset for data I/O               */
#define CFG_ATA_REG_OFFSET      0x0080  /* Offset for normal register access */
#define CFG_ATA_ALT_OFFSET      0x0100  /* Offset for alternate registers    */

#endif

/*
 * Boot Flags
 */
#define BOOTFLAG_COLD   0x01            /* Normal Power-On: Boot from FLASH */
#define BOOTFLAG_WARM   0x02            /* Software reboot */

#endif /* __CONFIG_H */
