/*
 * (C) Copyright 2003
 * John W. Linville, LVL7 Systems, Inc., linvill@lvl7.com.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* ------------------------------------------------------------------------- */

/*
 * board/config.h - configuration options, board specific
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * High Level Configuration Options
 * (easy to change)
 */

#define CONFIG_GSM73XX		1

#define CONFIG_MPC824X		1
#define CONFIG_MPC8245		1
#define CFG_ADDR_MAP_B		1

#define CONFIG_BOARD_PRE_INIT	1
#define CONFIG_MISC_INIT_R	1

#define CONFIG_CONS_INDEX	1
#define CONFIG_BAUDRATE		9600

#undef CONFIG_COM2_ENABLE

/*
 * Allow "null" console at boot...
 */
#define CFG_CONSOLE_IS_IN_ENV	1

/*
 * Remove extraneous console messages...
 */
#define CFG_CONSOLE_INFO_QUIET	1

#define CONFIG_BOOTDELAY	3
#define CONFIG_BOOTCOMMAND	"cp.b ffde0000 00400000 120000 ; " \
				"cp.b fff60000 00520000 a0000 ; " \
				"bootm 00400000"

#define CONFIG_BOOTARGS         "root=/dev/ram quiet"

#define CONFIG_EXTRA_ENV_SETTINGS "nfsprep=setenv bootargs root=/dev/nfs " \
                                  "ip=$ipaddr:$serverip:$gatewayip:$netmask ; "\
                                  "setenv bootcmd tftpboot \\; bootm\0" \
                                  "flashprep=setenv bootargs root=/dev/ram ; " \
                                  "setenv bootcmd " \
                                  "cp.b ffde0000 00400000 120000 \\; " \
                                  "cp.b fff60000 00520000 a0000 \\; " \
                                  "bootm 00400000\0" \
                                  "stdin=serial\0" \
                                  "stdout=null\0" \
                                  "stderr=null"

#define CONFIG_COMMANDS		( ( CONFIG_CMD_DFL | \
				    CFG_CMD_PCI    ) & \
				 ~( CFG_CMD_NET    ) )

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any)	*/
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP		1		/* undef to save memory */
#define CFG_PROMPT		"=> "		/* Monitor Command Prompt */

#define CFG_HUSH_PARSER
#ifdef  CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2	"> "
#endif

#define CFG_CBSIZE		1024		/* Console I/O Buffer Size */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)	/* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args */
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size */
#define CFG_LOAD_ADDR		0x00100000	/* default load address */
#define CFG_HZ			1000		/* dec freq: 1 ms ticks */

/*-----------------------------------------------------------------------
 * PCI stuff
 *-----------------------------------------------------------------------
 */
#define CONFIG_PCI				/* include pci support */
#define CONFIG_PCI_PNP

/*-----------------------------------------------------------------------
 * Start addresses for the final memory configuration
 * (Set up by the startup code)
 * Please note that CFG_SDRAM_BASE _must_ start at 0
 */
#define CFG_SDRAM_BASE		0x00000000
#define CFG_MAX_RAM_SIZE	0x08000000

#define CFG_RESET_ADDRESS	0xFFF00100

#define CFG_MONITOR_LEN		0x00030000
#define CFG_MONITOR_BASE	TEXT_BASE

#define CFG_GBL_DATA_SIZE	128

#define CFG_INIT_RAM_ADDR	0x01fff000
#define CFG_INIT_RAM_END	0x1000

#define CFG_GBL_DATA_OFFSET     (CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)

#define CFG_FLASH_BASE		0xFF000000
#define CFG_FLASH_SIZE		(8 * 1024 * 1024)	/* 8MB flash */

#define CFG_MALLOC_LEN		(512 << 10)	/* Reserve 512kB for malloc() */

#define CFG_MEMTEST_START	0x00000000	/* memtest works on */
#define CFG_MEMTEST_END		0x02000000	/* 0 ... 32 MB in DRAM */

#define CFG_EUMB_ADDR		0xFC000000

#define CFG_ENV_IS_IN_FLASH	1
#define CFG_ENV_OFFSET		0x00f20000
#define CFG_ENV_SECT_SIZE	0x00020000

#define CFG_VPD_OFFSET		0x00f40000
#define CFG_VPD_SECT_SIZE	0x00020000

#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }

/*
 * NS16550 Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL

#define CFG_NS16550_REG_SIZE	1

#define CFG_NS16550_CLK		132000000

#define CFG_NS16550_COM1	(CFG_EUMB_ADDR + 0x4500)
#define CFG_NS16550_COM2	(CFG_EUMB_ADDR + 0x4600)

/*
 * Low Level Configuration Settings
 * (address mappings, register initial values, etc.)
 * You should know what you are doing if you make changes here.
 */

#define CONFIG_SYS_CLK_FREQ	66000000	/* external frequency to pll */

#define CFG_ROMNAL		15	/* rom/flash next access time */
#define CFG_ROMFAL		31	/* rom/flash access time */
#define CFG_DBUS_SIZE2		1	/* bus size info for ^RCS1 */

#define CFG_ASRISE		8	/* ^AS rise time */
#define CFG_ASFALL		4	/* ^AS fall time */
#define CFG_REFINT		933	/* clock cycles between CBR refresh */

#define CFG_BSTOPRE		121	/* Burst To Precharge interval */
#define CFG_REFREC		8	/* Refresh to activate interval	*/

#define CFG_PRETOACT		3	/* Precharge to activate interval */
#define CFG_ACTTOPRE		5	/* Activate to Precharge interval */
#define CFG_EXTROM		1	/* Extended ROM space enable */
#define CFG_REGISTERD_TYPE_BUFFER	1
#define CFG_REGDIMM		0	/* Normal DIMMs */
#define CFG_SDMODE_CAS_LAT	2	/* SDMODE CAS latency	*/
#define CFG_SDMODE_WRAP		0	/* SDMODE wrap type	*/
#define CFG_ACTORW		3	/* Activate to R/W */

/* memory bank settings*/
/*
 * only bits 20-29 are actually used from these vales to set the
 * start/end address the upper two bits will be 0, and the lower 20
 * bits will be set to 0x00000 for a start address, or 0xfffff for an
 * end address
 */
#define CFG_BANK0_START		0x00000000
#define CFG_BANK0_END		(CFG_MAX_RAM_SIZE/2 - 1)
#define CFG_BANK0_ENABLE	1
#define CFG_BANK1_START		(CFG_MAX_RAM_SIZE/2)
#define CFG_BANK1_END		(CFG_MAX_RAM_SIZE - 1)
#define CFG_BANK1_ENABLE	1
#define CFG_BANK2_START		0x3ff00000
#define CFG_BANK2_END		0x3fffffff
#define CFG_BANK2_ENABLE	0
#define CFG_BANK3_START		0x3ff00000
#define CFG_BANK3_END		0x3fffffff
#define CFG_BANK3_ENABLE	0
#define CFG_BANK4_START		0x3ff00000
#define CFG_BANK4_END		0x3fffffff
#define CFG_BANK4_ENABLE	0
#define CFG_BANK5_START		0x3ff00000
#define CFG_BANK5_END		0x3fffffff
#define CFG_BANK5_ENABLE	0
#define CFG_BANK6_START		0x3ff00000
#define CFG_BANK6_END		0x3fffffff
#define CFG_BANK6_ENABLE	0
#define CFG_BANK7_START		0x3ff00000
#define CFG_BANK7_END		0x3fffffff
#define CFG_BANK7_ENABLE	0
/*
 * Memory bank enable bitmask, specifying which of the banks defined above
 are actually present. MSB is for bank #7, LSB is for bank #0.
 */
#define CFG_BANK_ENABLE		0x03

#define CFG_ODCR		0x7f	/* configures line driver impedances */
					/* see 8245 book for bit definitions */
#if 0 /* JWL -- is this working? */
#define CFG_PGMAX		0xf0	/* how long the 8245 retains the */
					/* currently accessed page in memory */
					/* see 8245 book for details */
#endif

/* SDRAM 0 - 256MB */
#define CFG_IBAT0L	(CFG_SDRAM_BASE | BATL_PP_10 | BATL_MEMCOHERENCE)
#define CFG_IBAT0U	(CFG_SDRAM_BASE | BATU_BL_256M | BATU_VS | BATU_VP)

/* RCS2 & RCS3 */
#define CFG_IBAT1L	(0x70000000 | BATL_PP_10 | BATL_CACHEINHIBIT)
#define CFG_IBAT1U	(0x70000000 | BATU_BL_256M | BATU_VS | BATU_VP)

/* PCI memory */
#define CFG_IBAT2L	(0x80000000 | BATL_PP_10 | BATL_CACHEINHIBIT)
#define CFG_IBAT2U	(0x80000000 | BATU_BL_256M | BATU_VS | BATU_VP)

/* Flash, config addrs, etc */
#define CFG_IBAT3L	(0xF0000000 | BATL_PP_10 | BATL_CACHEINHIBIT)
#define CFG_IBAT3U	(0xF0000000 | BATU_BL_256M | BATU_VS | BATU_VP)

#define CFG_DBAT0L	CFG_IBAT0L
#define CFG_DBAT0U	CFG_IBAT0U
#define CFG_DBAT1L	CFG_IBAT1L
#define CFG_DBAT1U	CFG_IBAT1U
#define CFG_DBAT2L	CFG_IBAT2L
#define CFG_DBAT2U	CFG_IBAT2U
#define CFG_DBAT3L	CFG_IBAT3L
#define CFG_DBAT3U	CFG_IBAT3U

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Memory map for Linux */
/*-----------------------------------------------------------------------
 * FLASH organization
 */
#define CFG_MAX_FLASH_BANKS	2	/* max number of memory banks */
#define CFG_MAX_FLASH_SECT	64	/* max number of sectors on one chip */

#define CFG_FLASH_ERASE_TOUT	120000	/* Timeout for Flash Erase (in ms) */
#define CFG_FLASH_WRITE_TOUT	1000	/* Timeout for Flash Write (in ms) */

#define CFG_FLASH_BASE0_PRELIM	0xff000000	/* bank 0 maybe not... */
#define CFG_FLASH_BASE1_PRELIM	0xff800000	/* bank 1 always there */

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_CACHELINE_SIZE	32	/* For MPC8240 CPU */
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#  define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
#endif

/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD		0x01	/* Normal Power-On: Boot from FLASH */
#define BOOTFLAG_WARM		0x02	/* Software reboot */

#endif	/* __CONFIG_H */
